{**************************************************}
{   TSignalDiscreteSeries Component Editor Dialog  }
{   Copyright (c) 1997-2001 by Janez Makovsek      }
{**************************************************}
{$IMPORTEDDATA ON}
unit SignalDiscreteSeriesEdit;
{$I BdsppDefs.inc}

interface

uses Windows, Messages,
     SysUtils, Classes,
     Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls, ComCtrls,
     Chart, Series, TeCanvas, TeePenDlg,TeeProcs, SignalSeriesTee;

type
  TSignalDiscreteSeriesEditor = class(TForm)
    GroupBox1: TGroupBox;
    CBColorEach: TCheckBox;
    BAreaColor: TButtonColor;
    GroupBox3: TGroupBox;
    CBUseOrigin: TCheckBox;
    Label1: TLabel;
    EOrigin: TEdit;
    UDOrigin: TUpDown;
    BAreaLinesPen: TButtonPen;
    procedure FormShow(Sender: TObject);
    procedure CBColorEachClick(Sender: TObject);
    procedure CBUseOriginClick(Sender: TObject);
    procedure EOriginChange(Sender: TObject);
  private
    { Private declarations }
    Area : TSignalDiscreteSeries;
    Procedure EnableOrigin;
    Function GetAreaColor:TColor;
  public
    { Public declarations }
  end;

implementation

{$R *.dfm}

Uses TeEngine, TeeBrushDlg, TeePoEdi, TeeConst;

procedure TSignalDiscreteSeriesEditor.FormShow(Sender: TObject);
begin
  Area:=TSignalDiscreteSeries(Tag);
  With Area do
  begin
    CBColorEach.Checked   :=ColorEachPoint;
    CBUseOrigin.Checked   :=UseYOrigin;
    UDOrigin.Position     :=Round(YOrigin);
    BAreaLinesPen.LinkPen(LinePen);
  end;
  With BAreaColor do
  begin
    GetColorProc:=GetAreaColor;
    LinkProperty(Area,'SeriesColor');
    Enabled := not Area.ColorEachPoint;
  end;
  EnableOrigin;
  TeeInsertPointerForm(Parent,Area.Pointer,TeeMsg_GalleryPoint);
end;

procedure TSignalDiscreteSeriesEditor.CBColorEachClick(Sender: TObject);
begin
  Area.ColorEachPoint:=CBColorEach.Checked;
  BAreaColor.Enabled:=not Area.ColorEachPoint;
end;

Function TSignalDiscreteSeriesEditor.GetAreaColor:TColor;
begin
  With Area do
  if AreaColor=clTeeColor then result:=SeriesColor
                          else result:=AreaColor;
end;

procedure TSignalDiscreteSeriesEditor.CBUseOriginClick(Sender: TObject);
begin
  Area.UseYOrigin:=CBUseOrigin.Checked;
  EnableOrigin;
end;

procedure TSignalDiscreteSeriesEditor.EOriginChange(Sender: TObject);
begin
  if Showing then Area.YOrigin:=UDOrigin.Position
end;

Procedure TSignalDiscreteSeriesEditor.EnableOrigin;
begin
  EOrigin.Enabled:=CBUseOrigin.Checked;
  UDOrigin.Enabled:=EOrigin.Enabled;
end;

initialization
  RegisterClass(TSignalDiscreteSeriesEditor);
end.
